export declare type DeepPartial<T> = T extends Primitive ? Partial<T> : T extends Array<any> ? T : T extends Set<any> ? T : T extends ReadonlySet<any> ? T : T extends Map<any, any> ? T : T extends ReadonlyMap<any, any> ? T : T extends Date ? Date : T extends (...args: any[]) => unknown ? T | undefined : T extends object ? DeepPartialObject<T> : unknown;
declare type Primitive = null | undefined | string | number | boolean | symbol | bigint;
declare type DeepPartialObject<ObjectType extends object> = {
    [KeyType in keyof ObjectType]?: DeepPartial<ObjectType[KeyType]>;
};
export {};
